"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.task = undefined;

var _babelCore = require("babel-core");

var babel = _interopRequireWildcard(_babelCore);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const opt = {
	auxiliaryCommentAfter: null,
	auxiliaryCommentBefore: null,
	babelrc: false,
	comments: true,
	compact: "auto",
	env: {},
	parserOpts: {},
	plugins: [],
	presets: [],
	retainLines: false,
	sourceType: "module"
};

let regexp = /^(.*)\((\d+)\:(\d+)\)\s*$/;

let task = exports.task = {
	transform(code, {
		auxiliaryCommentAfter = opt.auxiliaryCommentAfter,
		auxiliaryCommentBefore = opt.auxiliaryCommentBefore,
		babelrc = opt.babelrc,
		comments = opt.comments,
		compact = opt.compact,
		env = opt.env,
		parserOpts = opt.parserOpts,
		plugins = opt.plugins,
		presets = opt.presets,
		retainLines = opt.retainLines,
		sourceType = opt.sourceType,
		debug = false
	}) {
		var _this = this;

		return _asyncToGenerator(function* () {
			let options = {
				auxiliaryCommentAfter, auxiliaryCommentBefore, comments, compact,
				babelrc, env, parserOpts, plugins, presets, sourceType, sourceMaps: debug
			};
			try {
				let result = babel.transform(code, options);
				if (debug) {
					return result.code + "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + Buffer.from(JSON.stringify(result.map)).toString("base64");
					+"\n";
				}
				return result.code;
			} catch (e) {
				let ln,
				    cl,
				    tx = e.message;
				let info = regexp.exec(tx);
				if (info) {
					tx = info[1];
					ln = info[2];
					cl = info[3];
				}
				yield _this.echo({
					lv: "error",
					at: "babel",
					fn: _this.absPath,
					ln, cl, tx
				});
			}
		})();
	}
};